/* Public domain */

#ifndef SUDOKU_H
#define SUDOKU_H

typedef struct sudoku_grid sudoku_grid_s, *sudoku_grid_ref;

struct sudoku_grid {
	unsigned char number[81];
};

#define NB_CONDITIONS 27

unsigned char sudoku_conditions[NB_CONDITIONS][9];

int sudoku_check_conditions(sudoku_grid_ref);
void init_sudoku_grid(sudoku_grid_ref);
sudoku_grid_ref new_sudoku_grid(void);
void duplicate_sudoku_grid(sudoku_grid_ref dest, sudoku_grid_ref src);
void sudoku_fill_grid_from_stdin(sudoku_grid_ref);
void sudoku_display_grid(sudoku_grid_ref grid);
int sudoku_solve(sudoku_grid_ref grid);

#endif
